/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.gebietsbaum.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.gebietsbaum.entity.Wahldurchfuehrungsgebiet;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class WahldurchfuehrungsgebietExtendedDAO extends AbstractWahldurchfuehrungsgebietDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: CountErfassungsgebieteByWahlErgebniseingabestatusEndgueltigNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT count(g) FROM Wahldurchfuehrungsgebiet g WHERE g.wahl=?1 AND g.eingabestatusEndgueltig IN (?2) AND EXISTS (SELECT gae FROM Gebietsarteigenschaft gae WHERE gae.gebietsart=g.gebietsart AND gae.wahlart=(SELECT w.wahlart FROM Wahl w WHERE w=?1) AND gae.erfassungsgebiet=1)<br>
* SQL: <br>
*/
@Override
public java.lang.Long findByCountErfassungsgebieteByWahlErgebniseingabestatusEndgueltig( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.stimmeingabe.entity.Ergebniseingabestatus> ergebniseingangsstatus) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahldurchfuehrungsgebiet.findByCountErfassungsgebieteByWahlErgebniseingabestatusEndgueltig" ,  wahl ,  ergebniseingangsstatus  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByCountErfassungsgebieteByWahlErgebniseingabestatusEndgueltig(): Miss");
        }

        cache.put(key, super.findByCountErfassungsgebieteByWahlErgebniseingabestatusEndgueltig( wahl ,  ergebniseingangsstatus  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByCountErfassungsgebieteByWahlErgebniseingabestatusEndgueltig(): Hit");
      }

      return (java.lang.Long) cache.lookup(key);
    }

    return super.findByCountErfassungsgebieteByWahlErgebniseingabestatusEndgueltig( wahl ,  ergebniseingangsstatus  );
}
/**
* Name: CountErfassungsgebieteByWahlErgebniseingabestatusVorlaeufigNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT count(g) FROM Wahldurchfuehrungsgebiet g WHERE g.wahl=?1 AND g.eingabestatusVorlaeufig IN (?2) AND EXISTS (SELECT gae FROM Gebietsarteigenschaft gae WHERE gae.gebietsart=g.gebietsart AND gae.wahlart=(SELECT w.wahlart FROM Wahl w WHERE w=?1) AND gae.erfassungsgebiet=1)<br>
* SQL: <br>
*/
@Override
public java.lang.Long findByCountErfassungsgebieteByWahlErgebniseingabestatusVorlaeufig( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.stimmeingabe.entity.Ergebniseingabestatus> ergebniseingangsstatus) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahldurchfuehrungsgebiet.findByCountErfassungsgebieteByWahlErgebniseingabestatusVorlaeufig" ,  wahl ,  ergebniseingangsstatus  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByCountErfassungsgebieteByWahlErgebniseingabestatusVorlaeufig(): Miss");
        }

        cache.put(key, super.findByCountErfassungsgebieteByWahlErgebniseingabestatusVorlaeufig( wahl ,  ergebniseingangsstatus  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByCountErfassungsgebieteByWahlErgebniseingabestatusVorlaeufig(): Hit");
      }

      return (java.lang.Long) cache.lookup(key);
    }

    return super.findByCountErfassungsgebieteByWahlErgebniseingabestatusVorlaeufig( wahl ,  ergebniseingangsstatus  );
}
/**
* Name: ErfasstFuerGebieteNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Wahldurchfuehrungsgebiet o WHERE o.erfasstIn = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Wahldurchfuehrungsgebiet> findByErfasstFuerGebiete( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet uebergeordnetesGebiet) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahldurchfuehrungsgebiet.findByErfasstFuerGebiete" ,  uebergeordnetesGebiet  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByErfasstFuerGebiete(): Miss");
        }

        cache.put(key, super.findByErfasstFuerGebiete( uebergeordnetesGebiet  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByErfasstFuerGebiete(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Wahldurchfuehrungsgebiet>) cache.lookup(key));
    }

    return super.findByErfasstFuerGebiete( uebergeordnetesGebiet  );
}
/**
* Name: UebergeordnetesGebietNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Wahldurchfuehrungsgebiet o WHERE o.uebergeordnetesGebiet = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Wahldurchfuehrungsgebiet> findByUebergeordnetesGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet uebergeordnetesGebiet) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahldurchfuehrungsgebiet.findByUebergeordnetesGebiet" ,  uebergeordnetesGebiet  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByUebergeordnetesGebiet(): Miss");
        }

        cache.put(key, super.findByUebergeordnetesGebiet( uebergeordnetesGebiet  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByUebergeordnetesGebiet(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Wahldurchfuehrungsgebiet>) cache.lookup(key));
    }

    return super.findByUebergeordnetesGebiet( uebergeordnetesGebiet  );
}
/**
* Name: WahlNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Wahldurchfuehrungsgebiet o WHERE o.wahl =?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Wahldurchfuehrungsgebiet> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahldurchfuehrungsgebiet.findByWahl" ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahl(): Miss");
        }

        cache.put(key, super.findByWahl( wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahl(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Wahldurchfuehrungsgebiet>) cache.lookup(key));
    }

    return super.findByWahl( wahl  );
}
/**
* Name: WahlWurzelgebietNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT g FROM Wahldurchfuehrungsgebiet g WHERE g.wahl = ?1 AND g.uebergeordnetesGebiet IS NULL<br>
* SQL: <br>
*/
@Override
public Wahldurchfuehrungsgebiet findByWahlWurzelgebiet( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahldurchfuehrungsgebiet.findByWahlWurzelgebiet" ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlWurzelgebiet(): Miss");
        }

        cache.put(key, super.findByWahlWurzelgebiet( wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlWurzelgebiet(): Hit");
      }

      return (Wahldurchfuehrungsgebiet) cache.lookup(key);
    }

    return super.findByWahlWurzelgebiet( wahl  );
}
/**
* Name: WahlterminGebietsartNummerNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Wahldurchfuehrungsgebiet o WHERE o.wahltermin=?1 AND o.gebietsart=?2 AND o.nummer=?3<br>
* SQL: <br>
*/
@Override
public java.util.List<Wahldurchfuehrungsgebiet> findByWahlterminGebietsartNummer( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsart,  @javax.annotation.Nonnull String nummer) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahldurchfuehrungsgebiet.findByWahlterminGebietsartNummer" ,  wahltermin ,  gebietsart ,  nummer  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlterminGebietsartNummer(): Miss");
        }

        cache.put(key, super.findByWahlterminGebietsartNummer( wahltermin ,  gebietsart ,  nummer  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlterminGebietsartNummer(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Wahldurchfuehrungsgebiet>) cache.lookup(key));
    }

    return super.findByWahlterminGebietsartNummer( wahltermin ,  gebietsart ,  nummer  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
